-- Very complex AI code ahead, I don't blame you if it's confusing for you

local rot = Rotation()
local vec = Vector3()
local offset =  Vector3(0, 0, 200)

if Network:is_client() then
	return
end

local function enhanced_cloaker_ai(self, t)
	if self._state_data.reload_expire_t <= t then
		return
	end

	if not managers.groupai:state():enemy_weapons_hot() or math.random() < 0.4 then
		return
	end

	local target_area = managers.groupai:state():get_area_from_nav_seg_id(self._ext_movement:nav_tracker():nav_segment())
	if not target_area then
		return
	end

	local to_pos = self._ext_movement:m_head_pos()

	local areas = {}
	local check_areas = { target_area }
	local checked_areas = { target_area = true }
	repeat
		local area = table.remove(check_areas, 1)
		table.insert(areas, area)
		for _, n in pairs(area.neighbours) do
			if not checked_areas[n] and mvector3.distance_sq(to_pos, n.pos) < 4000000 then
				checked_areas[n] = true
				table.insert(check_areas, n)
			end
		end
	until #check_areas == 0

	local pos, accept_pos
	local look_dir = self._ext_movement:m_head_rot():y()
	local slotmask = managers.slot:get_mask("world_geometry")
	repeat
		local area = table.remove(areas, math.random(#areas))
		local nav_seg = table.random(table.map_keys(area.nav_segs)) or area.pos_nav_seg
		local tries = 20
		repeat
			tries = tries - 1
			pos = managers.navigation:find_random_position_in_segment(nav_seg)
			local dis = mvector3.direction(vec, to_pos, pos)
			accept_pos = dis > 300 and dis < 1500 and (mvector3.dot(vec, look_dir) < 0.5 or World:raycast("ray", pos + offset, to_pos, "slot_mask", slotmask, "report"))
		until accept_pos or tries == 0

		if accept_pos then
			break
		end
	until #areas == 0

	managers.navigation:search_pos_to_pos({
		pos_from = pos,
		pos_to = to_pos,
		id = "path" .. t,
		result_clbk = function (path)
			if not path then
				return
			end

			local unit_name = tweak_data.group_ai.unit_categories.spooc.unit_types[tweak_data.levels:get_ai_group_type()][1]
			local unit = World:spawn_unit(unit_name, pos, rot)
			unit:movement():set_team(managers.groupai:state():team_data("law1"))
			local brain = unit:brain()
			brain:set_logic("attack")
			brain._current_logic.damage_clbk(brain._logic_data, {attacker_unit = self._unit})
			local focus_enemy = brain._logic_data.detected_attention_objects[self._unit:key()]
			if not focus_enemy then
				return
			end

			CopLogicBase._set_attention(brain._logic_data, focus_enemy)
			brain._logic_data.internal_data.attention_unit = focus_enemy.u_key

			local action = unit:brain():action_request({
				body_part = 1,
				type = "spooc",
				nav_path = path
			})

			if action then
				brain._logic_data.internal_data.spooc_attack = {
					start_t = brain._logic_data.t,
					target_u_data = focus_enemy,
					action = action
				}
			end

		end
	})
end

Hooks:PostHook(PlayerStandard, "_start_action_reload", "_start_action_reload_clk", enhanced_cloaker_ai)
